"""Point normals, curvatures, etc."""

from ._moments import Moments, _point_moments
from .curvatures import (
    _point_curvature_colors,
    _point_curvedness,
    _point_mean_gauss_curvatures,
    _point_principal_curvatures,
    _point_quadratic_coefficients,
    _point_quadratic_fits,
    _point_shape_indices,
    smooth_curvatures,
    smooth_curvatures_2,
)
from .face_properties import (
    _edge_lengths,
    _edge_midpoints,
    _edge_points,
    _point_masses,
    _triangle_areas,
    _triangle_centroids,
    _triangle_points,
)
from .implicit_quadrics import implicit_quadrics
from .normals import (
    _point_frames,
    _point_normals,
    _triangle_area_normals,
    _triangle_normals,
    smooth_normals,
    tangent_vectors,
)

__all__ = [
    "Moments",
    "implicit_quadrics",
]
